# Welcome to Climate4Impact v2


This new version of the C4I portal. In this release we improved the search and data analysis functionalities, aiming at supporting climate change impact researchers with more flexibility in the way they access and manipulate the data provided by the Earth System Grid Federation (ESGF).

In this page we provide a short guide to the use of C4I v2.


## Do I need an account to use C4I v2?


You can access the portal as **guest** or as **ESGF Registred User**. On the home page we explain the main differences between the different profiles. To access C4I with your ESGF account and take advantange of all the C4I capabilities, please follow the instructions on our [Register](register) page.


<img src="images/home.png" alt="home" style="height:400px;width:800px;"/>


## How do I search for data?

In the ***Data Discovery Page*** you select the project you want to access the data from (CMIP6 - CMIP5 - CORDEX).

Once you have selected the project, the portal will display a page where you can compose queries interactively by combining different properties. These are shown in separated tabs on the top of the page (*variable*, *frequency*, *experiment*, *model*, *member*) and can be configured in any order.


<img src="images/search.png" alt="search" style="height:400px;width:800px;"/>

When configuring a specific property, to facilitate identifying the most relevant options, a subset of the possible values is presented, grouped by different topics. This is the *Scoped* view. This presentation mode can be changed by switching the knob at the top left of the screen, from *Scoped* to *Extended*. The *Extended* presentation mode will display, for each property, all the possible values available for the current query configuration.

In the image above we show that the summary of the current query is always displayed on the top of the screen. Each value can be interactively removed. Adding or removing a property value will always result in the live update of the  available choices for each property.

When selecting the Model, by clicking on ***Compare Model Performance*** at the bottom of the Model panel, users will be prompted with a page showing how the selected models (and the others available) foresee a change on a variable (Temperature/Precipitaton) compared to the past. The page is generated by using the [ESMValTool](https://cmip-esmvaltool.dkrz.de/) and, in combination with the bias, gives some confidence on the performance.

<img src="images/ESMVal.png" alt="ESMValTool" style="height:400px;width:800px;"/>


The discovery page also allows to switch between the different projects (CMIP5,CMIP6, CORDEX) and ESFG data providers. Based on the user's choice the available parameters will be updated and the search will narrow down to the selected subset of ESGF nodes (Read about the Node Filter in the Subsetting Section). By default C4I will search across the whole ESFG network.


**NOTE:** Access to CORDEX requires authorisation. C4I relies on a new authorisation infrastructure which still has to be adopted by those nodes delivering CORDEX data. Developments are ongoing.


## How do I select and download the data?

After you have prepared your query, C4I offers you more ways of accessing the data.

By pressing the ***Download*** button at the bottom of the ***Data Discovery Page*** page, C4I shows the list of datasets available in the ESGF that are matching your query. The list will be ordered by ***mirror*** (ESGF Data Node), so that you can easily select more datasets of interest from the same location. If needed, you can interactively change this default ordering.


<img src="images/select.png" alt="select" style="height:400px;width:800px;"/>

By clicking on the ***Link List*** button, a file containing the list of URLs associated with the data can be downloaded. The file is represented in the standard [metalink](https://en.wikipedia.org/wiki/Metalink), which can be used to download the data independently in your processing scripts, adopting generic software libraries, or by using the interactive clients already available.

**NOTE:** Each dataset in the list is associated with a resolvable DOI page that describes the metadata of the model and the experiment that produced the dataset. The page can be browsed by clicking on the file icon, under the DOI column. As an example, this [link](https://cera-www.dkrz.de/WDCC/ui/cerasearch/cmip6?input=CMIP6.ScenarioMIP.IPSL.IPSL-CM6A-LR.ssp585) corresponds to the page for the DOI *doi:10.22033/ESGF/CMIP6.5271*, associated with all the data of the *IPSL-CM6A* model and *ssp585* experiment.

### How do I prepare the data for analysis in C4I?

The ***Download*** page offers you the opportunity to access the new and experimental analysis functionalities of C4I. By clicking on ***Export To Notebook*** (or ***Resume Notebook***, in case you have already a workspace), C4I will automatically export to and manage the data in a [*JupyterLab*](https://jupyterlab.readthedocs.io) instance, which is made available for you to use.

<img src="images/getnotebook.png" alt="noteboook" style="height:400px;width:800px;"/>


C4I prepares the resources needed to provide you with a notebook workspace. This includes the execution of the data staging workflows that copies the selected data from the ESFG network to your storage, as well as the provision of the *Python* enviroment that you will be using to develop your analysis. This will include useful modules, such as *icclim, pandas, xarray, cartopy, etc. Workspaces offer ***very large storage***! We do not put hard limits, but we monitor their capacity in benefit of costs optimisation.  Workspaces are deleted after ***two weeks of no-use***. Read more about this in the ***Will my Jupyter Workspace expire?*** section.

To prevent the data staging workflows to timeout, given the occasional unresponsiveness or high-load on the remote ESGF nodes, on which we have no control, you will be allowed to stage 3GB per request. If you need more data, you can still do this by submitting a more requests.

This experimental environment is provided thanks to the SWIRRL API (Software for Reproducible Research Lab). The API delivers an enhanced version of *JupyterLab*, which is extended with a set of tools that allow you to **update**, **restore**, **share** and **reproduce** the progress of your research. You will find a guide on how to use SWIRRL![enter image description here](https://gitlab.com/uploads/-/system/project/avatar/17988184/Screenshot_2020-04-09_at_10.37.38.png?width=32) directly in your notebook ([C4I Workspace](/c4i-frontend/helpSwirrl)).


<img src="images/swirrl.png" alt="swirrl" style="height:400px;width:800px;"/>



**NOTE** Your *JupyterLab* instance may be accessible before all the data is copied to your storage. At the moment we do not support deletion or changes to the data already copied. This is to make sure that your data  is kept consistent and reproducible. However, you can choose to **Rollback** the last data staging workflow, or create a new enviroment at any time. For instance, by creating a new environment every time you want to address a new research objective, will keep the notebook focussed on your current interest.  Workspaces of particular interest can always saved as ***Snapshots*** to your GitHub account, as explained in the [C4I Workspace](/c4i-frontend/helpSwirrl) guide, to help reproducing them in the future. 

### Will my Jupyter Workspace expire?

Notebooks are kept alive for undetermined time, as long as there is activity on them. Otherwise, Jupyter workspaces ***will expire and deleted after two weeks of no use***. This allows us to free computational resources to serve active users. 

However, in order not to loose your work, you can save ***Snapshots*** of your progress directly to your ***GitHub*** account, as explained in the [C4I Workspace](/c4i-frontend/helpSwirrl) guide. Currently we keep the data that is associated with your ***Snapshots***, so your analysis environment may be recreated.    


### Are there examples to learn how to implement new analysis notebooks?

To help with developing your first analysis notebook, we have collected a number of examples. You can browse and download those you are interested in from the [IS-ENES3 GitLab repository](https://gitlab.com/is-enes-cdi-c4i/notebooks). By selecting in C4I the data mentioned in the notebook, you can  export the files to your *JupyterLab* instance,  upload the notebook files and, once the data has been copied (see the [C4I Workspace](/c4i-frontend/helpSwirrl) guide for details), you will be able to test, change and experiment youself with this new facility!


### Can I reduce the amount of data downloaded by subsetting?

Yes, this is possible. In the ***Nodes & Subsetting*** menu on the top of the ***Data Disovery*** interface, you can choose to use in your search those ESGF nodes that support subsetting services. This is a remote operation, based on OGC WPS (Web Processing Serivce), that will be made available at more nodes of the ESGF. C4I will integrate these services incrementally as they become available and update the list.

<img src="images/WPSNodeSelection.png" alt="subsetting" style="height:350px;width:800px;"/>


Choosing those nodes with WPS subsetting will activate the ***Subsetting*** button on the bottom right of the page. This  will allow you to select the datasets you are interested in, and to configure subsetting parameters. This feature is is linked to the worskpace. This means that the subsetting workflow will process the request remotely, and the resulting data will be downloaded to your *JupyterLab* instance, similarly to what happens with the data staging previously described. 

<img src="images/subsetting.png" alt="subsetting" style="height:350px;width:800px;"/>


## Questions and Feedback!

Please contact us on c4i@knmi.nl! or submit feedback via the [C4I Feedback](https://forms.gle/m9FRTABa7Xq79Kop8) form!
